### wege.py
### stellt die Funktionen fuer die Verwaltung der Wege bereit,
### wenn die Knotenliste verwendet wird

from funktionen import first,second,last,rest,cons
from gallenbacher_graph_kanten import *
# Verwendet wird davon die Liste kleiner_graph_kanten
# und die Zugriffsfunktion holeNachfolger(<aktuelle-stadt> , <graph>)

### ===== Hilfsfunktion neuer-weg =====
# Gibt zu einem Weg und zu einer Kante den verlaengerten Weg zurueck.
def neuer_weg(weg, kante):
    '''die Kante wird mit dem von-Knoten am Kopf uebergeben
    (von, nach, Bewertung)
    gibt den neuen Weg als Liste zurueck'''
    if not last(weg)==first(kante):
        print('Fehler:', last(weg),'<>',second(kante))
        return weg
    neuerWeg=[first(weg)+last(kante)]+weg[1:]+[kante[1]]
    return neuerWeg

### Wege sind Listen aus der Laenge und den besuchten Knoten
### (diese vorwaerts sortiert, wegen des Hinzufuegens mit append)
### Muster: [0, 'I']
##print ( neuer_weg([0, 'I'], ('I','C',40)) )

### ===== alle_nachfolge_wege =====
### iterative Variante
# gibt zum aktuellen Weg alle Wege zurueck, die sich aus den
# Nachfolgekanten der Knotenliste (zB zu C: [[I 40] [M 31] [X 23]] ergeben.
##def alle_nachfolge_wege(weg, graph):
##    nachfolger=holeNachfolger(last(weg), graph) # ohne den aktuellen Knoten
##    neueWege=[]
##    for nF in nachfolger:
##        neueWege.append(neuer_weg(weg,[last(weg)]+nF))
##    return neueWege
### rekursive Alternative 
def alle_nachfolge_wege(weg, graph):
    # aktuelle-stadt steht am Ende im weg
    return alle_bearbeitung(holeNachfolger(last(weg), graph), weg)
    
def alle_bearbeitung(die_nachfolger, weg):
    nachfolgeKanten=[]
    for kante in die_nachfolger:
        if not (second(kante) in weg): # nicht zurueck
            neuerWeg=[]+weg ## echte Kopie
            neuerWeg.append(second(kante))
            neuerWeg[0]=first(weg)+last(kante)
            nachfolgeKanten.append(neuerWeg)
    return nachfolgeKanten
        

#Tests:
##print ( alle_nachfolge_wege([0, 'I'], gallenbacher_graph_kanten) )        
### -> 
